//-----------------------------------------------------------------------------------------------
//    Copyright (c) 
//
//    Name: main.cpp
//    Author: Gluharev Aleksi Sergeevith (aivle1@yandex.ru)  aka "Aldaron"
//    :     (aivle1@yandex.ru)  aka "Aldaron"
//    17.01.2007
//    HTTP://LASTWORLD.NET.RU
//
//    
//-----------------------------------------------------------------------------------------------

#include <windows.h>
#include <d3d9.h>
#include <d3dx9.h>
#pragma comment (lib, "d3d9.lib")
#pragma comment (lib, "d3dx9.lib")

#define D3DFVF_CUSTOMVERTEX ( D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX2 )

HWND               hWnd               = NULL;
LPDIRECT3D9        apD3D               = NULL;
LPDIRECT3DDEVICE9  d3d_Device         = NULL;

D3DXMATRIX matWorld;
D3DXMATRIX matView;
D3DXMATRIX matProj;

//
LPDIRECT3DVERTEXBUFFER9 mesh_VertexBuffer;
LPDIRECT3DINDEXBUFFER9 mesh_IndexBuffer;
LPD3DXMESH aMesh;
int Size_of_Mesh_Vertex;

//  
LPDIRECT3DTEXTURE9 aTexture;
LPDIRECT3DTEXTURE9 aTexture_Bump;
LPDIRECT3DTEXTURE9 aTexture_Height;
D3DMATERIAL9 Material;
// 
D3DLIGHT9 light;

// 
    D3DXMATRIX matOrientation;
    D3DXVECTOR3 cam_Position;
    D3DXVECTOR3 cam_Rotation;
//-----------------------------------
//

	ID3DXEffect *aEffect;
//-----------------------------------------------------------------------------
// Name: Render_Object()
//       
//-----------------------------------------------------------------------------
	void Render_Object(void)
	{
	aMesh->DrawSubset(0);
	}
//-----------------------------------------------------------------------------
// Name: Load_Effect()
//     
//        : http://www.lastworld.net.ru/
//  :  (  : ID3DXEffect)
//-----------------------------------------------------------------------------
	void Load_Effect(void)
	{
	D3DXCreateEffectFromFile(d3d_Device, "ald_Parallax_Mapping.fx", NULL, NULL, 0, NULL, &aEffect, NULL); 
	}

//-----------------------------------------------------------------------------
// Name: Render_Effect()
//  
//        : http://www.lastworld.net.ru/
//  :  (  : ID3DXEffect)
//-----------------------------------------------------------------------------
	void Render_Effect(void)
	{
    D3DXMATRIX nWorld;
	D3DXMatrixIdentity(&nWorld);

	D3DXMATRIX mat_World_View_Proj = nWorld * matView * matProj;
    D3DXVECTOR4 ViewPos = D3DXVECTOR4(cam_Position.x, cam_Position.y, cam_Position.z, 1.0f);
    D3DXVECTOR4 LightPos = D3DXVECTOR4(1.5f, -1.5f, 1.0f, 1.0f);
	D3DXVECTOR4 LightColor = D3DXVECTOR4(1.0f, 1.0f, 1.0f, 1.0f);

	aEffect->SetMatrix( "mat_World_View_Proj", &mat_World_View_Proj );
	aEffect->SetMatrix( "matWorld", &nWorld );

	aEffect->SetVector( "View_Pos", &ViewPos);
	aEffect->SetVector( "LightPos", &LightPos);

	aEffect->SetVector( "LightColor", &LightColor);
	aEffect->SetFloat(  "LightFalloff", 40.0f );
	aEffect->SetFloat(  "LightSpecular", 1.5f );
	aEffect->SetFloat(  "LightAmbient", 0.2f );
	aEffect->SetFloat(  "ParallaxDepth", 0.03f );
	aEffect->SetFloat(  "Attenuation", 2.0f );

	aEffect->SetTexture( "baseMap", aTexture );
	aEffect->SetTexture( "normalMap", aTexture_Bump );
	aEffect->SetTexture( "heightMap", aTexture_Height );

    aEffect->SetTechnique( "a_Parallax_Map" );

	
	UINT aPasses;
	aEffect->Begin(&aPasses, 0);
	for (UINT Pass = 0; Pass<aPasses; Pass++)
	{
	aEffect->BeginPass(Pass);
		
    Render_Object();

	aEffect->EndPass();
	}
	aEffect->End();
	
	}


//-----------------------------------------------------------------------------
// Name: LoadMesh()
//    
//  
//  
//  
//-----------------------------------------------------------------------------
void LoadMesh(void)
{
    ID3DXMesh* Temp;

	D3DXLoadMeshFromX("box.x",D3DXMESH_SYSTEMMEM,d3d_Device,	NULL,NULL,NULL,NULL,&aMesh);

	//,   ""  
	D3DVERTEXELEMENT9 Elements[] =
	{
	{ 0, sizeof( float ) * 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
	{ 0, sizeof( float ) * 3, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0 },
	{ 0, sizeof( float ) * 6, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
	{ 0, sizeof( float ) * 8, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TANGENT, 0 },
	{ 0, sizeof( float ) * 11, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BINORMAL, 0 },
	D3DDECL_END()
	};

	//  
	aMesh->CloneMesh(D3DXMESH_MANAGED,
		             Elements,
					 d3d_Device,
					 &Temp);
	aMesh->Release();
	aMesh = Temp;
	void* vDATA;
	aMesh->LockVertexBuffer(D3DLOCK_DISCARD, &vDATA);
	aMesh->UnlockVertexBuffer();
	D3DXComputeTangentFrame(aMesh, 0);//  Tangent 

	//----------------------------------------------------------*********************************
	// 
	D3DXCreateTextureFromFile(d3d_Device,"lastworld.jpg",&aTexture);
	D3DXCreateTextureFromFile(d3d_Device,"lastworld_normal.jpg",&aTexture_Bump);
	D3DXCreateTextureFromFile(d3d_Device,"lastworld_height.jpg",&aTexture_Height);


}
//-----------------------------------------------------------------------------
// Name: AppInit()
//  DirectX
//-----------------------------------------------------------------------------
bool AppInit(void)
{
    apD3D = Direct3DCreate9( D3D_SDK_VERSION );

    D3DDISPLAYMODE d3ddm;

    apD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm );

    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof(d3dpp) );

    d3dpp.Windowed               = TRUE;
    d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat       = d3ddm.Format;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
    d3dpp.PresentationInterval   = D3DPRESENT_INTERVAL_IMMEDIATE;

    apD3D->CreateDevice(D3DADAPTER_DEFAULT,
		                 D3DDEVTYPE_HAL,hWnd,
		                 D3DCREATE_HARDWARE_VERTEXPROCESSING,
								&d3dpp,&d3d_Device);


	
   D3DXMatrixPerspectiveFovLH (&matProj, D3DX_PI/4, 1.2f, 1.0f, 800.0f);// 

	//    
	cam_Position        = D3DXVECTOR3( 0.0f, 4.0f,-20.0f );
	

	LoadMesh();// 


	Load_Effect();//  ( )
	return 1;
}


    
//-----------------------------------------------------------------------------
// Name: CameraRender()
//  
//-----------------------------------------------------------------------------
void CameraRender(void)
{ 

	D3DXQUATERNION qR;
	
    D3DXQuaternionRotationYawPitchRoll( &qR,cam_Rotation.x, cam_Rotation.y, cam_Rotation.z );

	//    matOrientation
    D3DXMatrixAffineTransformation( &matOrientation, 1.25f, NULL, &qR, &cam_Position );

	//      
	D3DXMatrixInverse( &matView,NULL, &matOrientation );

	// 
	d3d_Device->SetTransform (D3DTS_WORLD, &matWorld );
	d3d_Device->SetTransform (D3DTS_VIEW, &matView );
   	d3d_Device->SetTransform (D3DTS_PROJECTION, &matProj);
	
}
//-----------------------------------------------------------------------------
// Name: render()
//  
//-----------------------------------------------------------------------------
void Render( void )
{
    d3d_Device->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
                         D3DCOLOR_COLORVALUE(10.0f,10.0f,10.0f,1.0f),
						 1.0f, 0 );

    d3d_Device->BeginScene();// 

	d3d_Device->SetFVF( D3DFVF_CUSTOMVERTEX );

    CameraRender();//  



	Render_Effect();// (   )  (   )
   

    d3d_Device->EndScene();// 
    d3d_Device->Present( NULL, NULL, NULL, NULL );
}

//-----------------------------------------------------------------------------
// Name: Destroy()
//  
//   
//-----------------------------------------------------------------------------
void Destroy(void)
{
	
	if(aMesh) aMesh->Release();
    if(d3d_Device)   d3d_Device->Release();
	if(apD3D)  apD3D->Release(); 
    
}

  
//------------------------------------------------------------------------------------------------
// WindowMsgProc()
//    
//------------------------------------------------------------------------------------------------
LRESULT WINAPI WindowProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch(msg) {
		
		case WM_DESTROY:
			PostQuitMessage(0);
		case WM_KEYDOWN:
		{
			// 
			if(wParam==VK_DOWN)
			{
				cam_Position.x-=(float)sin(cam_Rotation.x);
				cam_Position.z-=(float)cos(cam_Rotation.x);
			}
			// 
			if(wParam==VK_UP)
			{
				cam_Position.x+=(float)sin(cam_Rotation.x);
				cam_Position.z+=(float)cos(cam_Rotation.x);
			}
			if(wParam==VK_LEFT)cam_Rotation.x-=0.1f;// 
			if(wParam==VK_RIGHT)cam_Rotation.x+=0.1f;// 
		};
			return 0;
	}
	return DefWindowProc(hWnd,msg,wParam,lParam);
}

//------------------------------------------------------------------------------------------------
// WinMain 
//   
//------------------------------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{

	MSG msg;

	WNDCLASSEX wc =	{sizeof(WNDCLASSEX),
		CS_CLASSDC,WindowProc,
		0,0,
		GetModuleHandle(NULL),
		NULL,
		NULL,
		NULL,
		NULL,
		"D3D_Lesson_Parallax_Mapping",
		NULL};


	RegisterClassEx(&wc);
	
	hWnd = CreateWindow("D3D_Lesson_Parallax_Mapping",
		                  "Trial - Lesson_Parallax_Mapping - (www.lastworld.net.ru)",
						  WS_OVERLAPPEDWINDOW,
						  10,10,
						  640,480,
					      GetDesktopWindow(),
						  NULL,
						  GetModuleHandle(NULL),
						  NULL);

	ShowWindow(hWnd,SW_SHOWNORMAL);

    AppInit();

	while (1)
	{
		if(PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if(!GetMessage (&msg, NULL, 0, 0)) break;
			TranslateMessage (&msg); 
			DispatchMessage (&msg);
		}
		else
		{ 	
		
			Render();
		};
	};
	Destroy();
	return 0;


	};


